/* 
 * File:   My_RTCC.h
 * Author: Ryotaro Onuki
 *
 * Created on 2015/03/19, 0:02
 * 
 * PIC18F28J53pA^CNbNvO
 * Tv
 * ̃vOł́AϐRB
 * 1.PICRTCCW[̃WX^J_[\LA16i@\Liɂ10i֋X16iƂBj
 * 2.time_t\̓epochiuint32_tj2000N11000̑b
 * 3.time_t\̓YY,MM,DD,EE,hh,mm,ssꂼANAAAjAAAb10i@\LB
 * ȏRBςĂRTCC_loop()֐ׂĂ̒lɈvĂ̂ňSĎgpłB
 * g
 * 1.TIOSC̃s32.768kHz̃NX^ȂBi12p̃RfTj
 * 2.CONFIGݒ肷BRTCOSC = T1OSCREF
 * 3.̎ɁARTCC_init();Biݒ֐j
 * 4.main[vɁARTCC_loop();ƁBiԂ̓֐j
 * 5.CӂŎv킹Bv킹ARTCC_from_caltime()RTCC_from_epoch()ĂŕύXKpB
 * 6.v킹ɂ́Aadjust_time_toggle()ĂłAadjust_time_cursor()ŁADȍI
 * 7.adjust_time_inc()adjust_time_dec()ŒƂ悢B
 * 8.v킹IAadjust_time_toggle()xĂԂƎv킹IB
 */

#ifndef MY_RTCC_H
#define	MY_RTCC_H

#include <xc.h>
#include <stdint.h>
#include "My_button.h"

// ꂼ̕b`
#define MINUTE ((epoch_t)60)
#define HOUR ((epoch_t)60*60)
#define DAY ((epoch_t)60*60*24)

// epoch^`B2000N11000̑bB

typedef uint32_t epoch_t;

// 킹p̃tO̍\̂`B

typedef struct {

    union {
        uint8_t flags;

        struct {
            uint8_t ss : 1;
            uint8_t mm : 1;
            uint8_t hh : 1;
            uint8_t DD : 1;
            uint8_t MM : 1;
            uint8_t YY : 1;
        } flag;
    };
} edit_t;

// RTCC֘AׂĂl߂\́BۂɎgpB

typedef struct {
    epoch_t epoch;
    uint8_t ss;
    uint8_t mm;
    uint8_t hh;
    uint8_t EE;
    uint8_t DD;
    uint8_t MM;
    uint8_t YY;
    uint8_t colon;
    uint8_t halfsec;
    edit_t edit;
} time_t;

// \p̗jcharconstŒ`B
extern const char weekday_3char[7][4];

// ݎ
extern time_t now;
// ԂςtOoB\̎̍XV͂̃tO̊Ďčs΂悢B
extern uint8_t time_change_flag;
// main_init()ɏƁB
void RTCC_init(void);
/********************************** necessary functions **********************************/
// from decimal to hex
uint8_t d_to_x(uint8_t dec);
// from hex to decimal
uint8_t x_to_d(uint8_t hex);
// return month length
uint8_t month_length(uint8_t year, uint8_t month);
// quotdivŊāA]ԂB悭ĝŊ֐B
epoch_t get_quot_rem(epoch_t *quot, uint8_t div);
/********************************** Transform time **********************************/
// RTCCJ_^CɕϊA㏑B
void RTCC_to_caltime(time_t *tm);
// J_^CRTCCɕϊA㏑B
void caltime_to_RTCC(time_t *tm);
// EpochJ_^CɕϊA㏑B
void epoch_to_caltime(time_t *tm);
// 
void caltime_to_epoch(time_t *tm);
/********************************** Transform time User Functions **********************************/
// RTCCł낦
void RTCC_from_RTCC(time_t *tm);
// J_[^Cł낦
void RTCC_from_caltime(time_t *tm);
// G|bNł낦
void RTCC_from_epoch(time_t *tm);
/********************************** LCD display **********************************/
// eڕ\p֐B[U[͎gȂB
void display_dec(char *str, uint8_t dec, uint8_t edit);
// 0802TCYtpA쐬֐
void display_time_0802(time_t *tm, char *line0, char *line1);
// 1608TCYtpA쐬֐
void display_time_1602(time_t *tm, char *line0, char *line1);
/********************************** adjust the time **********************************/
// ҏW[h؂ւ
void RTCC_adjust_time_toggle(time_t *tm);
// ҏW̎j؂ւ
void RTCC_adjust_time_cursor(time_t *tm);
// ҏW̎jP₷
void RTCC_adjust_time_inc(time_t *tm);
// ҏW̎jP炷
void RTCC_adjust_time_dec(time_t *tm);
// 3̃{^Ŏ킹
void RTCC_adjust_time_button(time_t *tm, button_t *mode, button_t *cnt_inc, button_t *cnt_dec);
// Time sync
void RTCC_task(void);

#endif	/* MY_RTCC_H */
